import java.util.Scanner;

public class RooksOnChessboard {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
		
		int numCases = input.nextInt(); input.nextLine();

        for(int i = 0; i < numCases; i++) {
            int numRooks = input.nextInt();

            int[] pos_x = new int[numRooks];
            int[] pos_y = new int[numRooks];

            for(int j = 0; j < numRooks; j++) {
                pos_x[j] = input.nextInt();
                pos_y[j] = input.nextInt();
            }
			input.nextLine();
            if(solveRooks(pos_x, pos_y))
                System.out.println("Safe");
            else System.out.println("Threatened");
        }
    }
	
	private static boolean solveRooks(int [] pos_x, int [] pos_y) {
        boolean isSafe = true;

        boolean[] x_checked = new boolean[9]; 
        boolean[] y_checked = new boolean[9];

        for(int i = 0; i < x_checked.length; i++) {
            x_checked[i] = false; y_checked[i] = false;
        }

        for(int i = 0; i < pos_x.length; i++) {
            if(x_checked[pos_x[i]] || y_checked[pos_y[i]]) {
                isSafe = false; break;
            } else {
                x_checked[pos_x[i]] = true;
                y_checked[pos_y[i]] = true;
            }
        }
        return isSafe;
    }
}
