import java.util.Scanner;

public class GasStation {
    public static void main(String[] args){

        Scanner input = new Scanner(System.in);
        int numSets = input.nextInt();
        input.nextLine();

        for(int k = 0; k < numSets; k++){
            int stations = input.nextInt();
            double gallons = input.nextDouble();
            double mpg = input.nextDouble();
            double wearPerMile = input.nextDouble();
            
            double minCost = Double.MAX_VALUE;
            int index = -1;
            
            for(int j = 1; j <= stations; j++) {
                
                double distance = input.nextDouble() * 2;
                double price = input.nextDouble();
                double cost = price * gallons + distance / mpg * price;
                cost += distance * wearPerMile;
                if(cost < minCost) {
                    minCost = cost;
                    index = j;
                }
                // System.out.println(j + " " + cost);    
            }
            // System.out.println(minCost);
            System.out.print(index + " ");
            System.out.printf("%.2f", minCost);
            System.out.println();
        }
    }
    
 
}

