
import java.util.Scanner;

public class Look_N_Say {
	public static void main(String[] args) {
		Scanner input = new Scanner(System.in);
		
		int K = input.nextInt(); input.nextLine();
		for (int k = 0; k < K; k++) {
			String s = input.nextLine();
			int n = Integer.parseInt(input.nextLine());
			//System.out.println("------------first solution-------");
			lookandsay1(s, n);
			//System.out.println("------------second solution-------");
			//lookandsay2(s, n);
		}
	}

	public static String lookandsay1(String seed, int n) {
		String output = seed;

		for (int i = 0; i < n; i++) {
			output = looknsay11(output);
			//System.out.println(output); //print all the items
		}
		System.out.println(output);    //print the last one
		return output;
	}
	public static String looknsay11(String ss) {
		String output = "";
		char counting = 0; int count = 0;
		for (int i = 0; i < ss.length(); i++) {
			if (ss.charAt(i) != counting) {
				if (i > 0) {
					output += count; output += counting;
				}
				counting = ss.charAt(i); count = 1;
			} else { count++; }
		}
		output += count; output += counting;

		return output;
	}
	
	public static void lookandsay2(String output, int n){
		for (int i = 0; i < n; i++) {
			StringBuilder result= new StringBuilder();
			char repeat= output.charAt(0);
			output= output.substring(1) + " ";
			int times= 1;
		 
			for(char actual: output.toCharArray()){
				if(actual == repeat) times += 1;
				else {
					result.append(times + "" + repeat);
					times= 1; repeat= actual;
				}
			}
			
			output = result.toString();
			//System.out.println(output);    //print every item
		}
		
		System.out.println(output);    //print the last one
	}
}